// EnumPrinters.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

static void* EnumeratePrinters(DWORD flag, LPTSTR name, DWORD level, DWORD & nPrinters)
{
  DWORD cbNeeded;
  nPrinters = 0;
  EnumPrinters(flag, name, level, NULL, 0, & cbNeeded, & nPrinters);

  BYTE * pPrnInfo = new BYTE[cbNeeded];
  if ( pPrnInfo )
    EnumPrinters(flag, name, level, (BYTE *) pPrnInfo, cbNeeded,
      & cbNeeded, & nPrinters);

  return pPrnInfo;
}

int GetPrinterResolution(LPTSTR printerName)
{
	int printer_resolution = 0;

	TCHAR szDeviceName[MAX_PATH];
	_tcscpy(szDeviceName, printerName);
	HANDLE hPrinter;
	::OpenPrinter(szDeviceName, &hPrinter, NULL);

	DWORD cbNeeded = 0;
	::GetPrinter(hPrinter, 2, NULL, 0, & cbNeeded);
	if ( cbNeeded>0 ) {
	  PRINTER_INFO_2 * pInfo2 = NULL;
	  pInfo2 = (PRINTER_INFO_2 * ) new BYTE[cbNeeded];
	  ::GetPrinter(hPrinter, 2, (BYTE *) pInfo2, cbNeeded, & cbNeeded);
	  HDC hDC = CreateDC(pInfo2->pDriverName, pInfo2->pPrinterName,
			pInfo2->pPortName, pInfo2->pDevMode);

	  if ( hDC != 0 ) {
		printer_resolution = ::GetDeviceCaps(hDC, LOGPIXELSX);
		::DeleteDC(hDC);
	  }
	  delete[] (BYTE*)pInfo2;
	}

	::ClosePrinter(hPrinter);

	return printer_resolution;
}


int _tmain(int argc, _TCHAR* argv[])
{
	//step 2. Enumerate all the printers installed in the computer - including
	//local and network printers.
	DWORD nPrinters;
	PRINTER_INFO_5 * pInfo5 = NULL;
	pInfo5 = (PRINTER_INFO_5 *)EnumeratePrinters(PRINTER_ENUM_LOCAL,
		  NULL, 5, nPrinters);
	if ( pInfo5 ) {
	  for(unsigned int i=0; i<nPrinters; i++) {
		printf("Local Printer %S\t\t%d.\n", pInfo5[i].pPrinterName, 
			GetPrinterResolution(pInfo5[i].pPrinterName) );
	  }
	  delete [] (BYTE *) pInfo5;
	}
	PRINTER_INFO_1 * pInfo1 = NULL;
	pInfo1 = (PRINTER_INFO_1 *) EnumeratePrinters(PRINTER_ENUM_CONNECTIONS, NULL, 1, nPrinters);
	if ( pInfo1 ) {
	  for (unsigned i=0; i<nPrinters; i++)  {
		  printf("Remote Printer %S\t\t%d.\n", pInfo1[i].pName,
			  GetPrinterResolution(pInfo1[i].pName) );
	  }
	  delete [] (BYTE *) pInfo1;
	}

	return 0;
}

